#ifndef __Cm__CmMessage_ph__
#define __Cm__CmMessage_ph__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void CmMessageInitialize ();
CmMessage CmMessageNew ();
void CmMessageSetType (CmMessage message, char* type);

char* CmMessageGetType (CmMessage message);
CmMessageState CmMessageGetState (CmMessage message);
CmConnect CmMessageGetConnect (CmMessage message);
int CmMessageGetMessageLength (CmMessage message);
CmMessageItemType CmMessageGetItemType (CmMessage message);
char CmMessageGetChar (CmMessage message);
short CmMessageGetShort (CmMessage message);
int CmMessageGetInt (CmMessage message);
long CmMessageGetLong (CmMessage message);
float CmMessageGetFloat (CmMessage message);
double CmMessageGetDouble (CmMessage message);
char* CmMessageGetText (CmMessage message);
char* CmMessageGetBytes (CmMessage message, int* returnedLength);

void CmMessagePutChar (CmMessage message, char value);
void CmMessagePutShort (CmMessage message, short value);
void CmMessagePutInt (CmMessage message, int value);
void CmMessagePutLong (CmMessage message, long value);
void CmMessagePutFloat (CmMessage message, float value);
void CmMessagePutDouble (CmMessage message, double value);
void CmMessagePutText (CmMessage message, char* value);
void CmMessagePutBytes (CmMessage message, char* value, int length);

int CmMessageSend (CmMessage message, char* name);

void CmMessageDelete (CmMessage message);
CmMessageStatus CmMessageIteratorCallHandler (CmMessageIterator iterator);
void CmMessageIteratorStop (CmMessageIterator iterator);
int CmMessageIteratorFinished (CmMessageIterator iterator);
void CmMessageIteratorForth (CmMessageIterator iterator);
void CmMessagePrepareHandler (CmConnect connect);
int CmMessageStartup (char* name);
int CmMessageStartupMultiple (char* name);
void CmMessageCleanup ();
void CmMessageIteratorDelete (CmMessageIterator iterator);
void CmMessageCheckBalance ();
CmConnectPrinter CmMessageInstallPrinter (CmConnectPrinter printer);
int CmMessageOpenServer (char* name);
void CmMessageReset (CmMessage message);
CmConnectCondition CmMessageWait ();
CmConnectCondition CmMessageWaitWithTimeout (double seconds);
int CmMessageOpenMultipleServer (char* name);
CmConnectCondition CmMessageCheck ();
CmConnect CmConnectScan (CmConnectIterator it);
CmConnectCondition CmMessageServerWait (char* pattern);
int CmMessageCloseServer (char* name);
CmMessageHandler CmMessageInstallDefaultHandler (CmMessageHandler function);

CmMessageIterator CmMessagePost (CmMessage message, char* name,
                                 CmMessageHandler handler);

CmMessageHandler CmMessageInstallHandler (CmMessageHandler function,
                                          char* type);

void CmMessagePutArray (CmMessage message, CmMessageArrayType type,
                        int elements, void* address);

void* CmMessageGetArray (CmMessage message, CmMessageArrayType* typeRef,
                         int* elementsRef);

void CmMessagePutExtArray (CmMessage message, CmMessageArrayType type,
                           int elements, void* address);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __Cm__CmMessage_ph__ */
